-----------------------3.2.5 start----------------------
ALTER TABLE `exam_detail`
    ADD COLUMN `backup_count` DOUBLE NULL COMMENT '试卷、题卡备份数量（0-1为按比例，大于等于1为按数量）' AFTER `print_count`;

update exam_detail ed set ed.backup_count = (select backup_count from exam_print_plan epp where ed.print_plan_id = epp.id) where ed.id > 0;

ALTER TABLE `exam_print_plan`
    CHANGE COLUMN `backup_count` `backup_count` DOUBLE NOT NULL COMMENT '试卷、题卡备份数量（0-1为按比例，大于等于1为按数量）' ;

ALTER TABLE `basic_print_config`
    CHANGE COLUMN `backup_count` `backup_count` DOUBLE NULL DEFAULT NULL COMMENT '试卷、题卡备份数量（0-1为按比例，大于等于1为按数量）' ;

INSERT INTO `sys_privilege` (`id`, `name`, `url`, `type`, `parent_id`, `sequence`, `property`, `related`, `enable`, `default_auth`, `front_display`) VALUES ('867', '下载', 'Download', 'LINK', '624', '9', 'AUTH', '868', '1', '0', '1');
INSERT INTO `sys_privilege` (`id`, `name`, `url`, `type`, `parent_id`, `sequence`, `property`, `enable`, `default_auth`, `front_display`) VALUES ('868', '下载', '/api/admin/exam/card/download_card', 'URL', '624', '6', 'AUTH', '1', '1', '1');
INSERT INTO `sys_privilege` (`id`, `name`, `url`, `type`, `parent_id`, `sequence`, `property`, `enable`, `default_auth`, `front_display`) VALUES ('869', '试卷题卡预览日志记录接口', '/api/admin/basic/operation_log/save_preview_log', 'URL', '149', '14', 'SYS', '1', '1', '1');
INSERT INTO `sys_privilege` (`id`, `name`, `url`, `type`, `parent_id`, `sequence`, `property`, `related`, `enable`, `default_auth`, `front_display`) VALUES ('870', '结束', 'Finish', 'LINK', '43', '4', 'AUTH', '871', '1', '0', '1');
INSERT INTO `sys_privilege` (`id`, `name`, `url`, `type`, `parent_id`, `sequence`, `property`, `enable`, `default_auth`, `front_display`) VALUES ('871', '结束', '/api/admin/exam/print/plan_finish', 'URL', '43', '7', 'AUTH', '1', '1', '1');

UPDATE `sys_privilege` SET `enable` = '0', `front_display` = '0' WHERE (`id` = '306');

ALTER TABLE `basic_card_rule`
    CHANGE COLUMN `objective_attention` `objective_attention` TEXT NULL COMMENT '客观题注意事项' ,
    CHANGE COLUMN `subjective_attention` `subjective_attention` TEXT NULL COMMENT '主观题注意事项' ;

UPDATE `sys_privilege` SET `name` = '撤回提交' WHERE (`id` = '335');
INSERT INTO `sys_privilege` (`id`, `name`, `url`, `type`, `parent_id`, `sequence`, `property`, `related`, `enable`, `default_auth`, `front_display`) VALUES ('872', '批量撤回', 'BatchEnd', 'BUTTON', '47', '3', 'AUTH', '873', '1', '0', '1');
INSERT INTO `sys_privilege` (`id`, `name`, `url`, `type`, `parent_id`, `sequence`, `property`, `enable`, `default_auth`, `front_display`) VALUES ('873', '批量撤回', '/api/admin/exam/print/task_batch_cancel', 'URL', '47', '4', 'AUTH', '1', '1', '1');

UPDATE `sys_privilege` SET `related` = '395,435,557,665,792,793' WHERE (`id` = '394');
UPDATE `sys_privilege` SET `related` = '395,435,557,665,792,793' WHERE (`id` = '397');

ALTER TABLE `exam_detail` DROP COLUMN `print_count`;

-- 更新专卡对应的题卡规则ID
update exam_card t set t.card_rule_id = (select bpc.card_rule_id from basic_print_config bpc join exam_task et on bpc.school_id = et.school_id and bpc.exam_id = et.exam_id
                                                                                             join exam_task_detail etd on et.id = etd.exam_task_id
                                         where FIND_IN_SET(t.id, REPLACE(REPLACE(substring_index(substring_index(CONVERT((etd.paper_attachment_ids ->>'$[*].cardId') USING utf8), ']', 1), '[',-1),' "','"'),'"','')) )
where t.type = 'CUSTOM' and t.card_rule_id is null and t.id > 0;


CREATE TABLE `exam_detail_course_paper_type` (
      `id` BIGINT(20) NOT NULL,
      `exam_detail_course_id` BIGINT(20) NOT NULL,
      `paper_type` VARCHAR(5) NOT NULL COMMENT '卷型',
      PRIMARY KEY (`id`));
ALTER TABLE `exam_detail_course_paper_type`
    ADD INDEX `idx_exam_detail_course_id` (`exam_detail_course_id` ASC);

insert into exam_detail_course_paper_type select id + cast(FLOOR(RAND()*10000000000000) as signed), id, paper_type from exam_detail_course where paper_type is not null and id>0;

-----------------------3.2.5 end----------------------